.486
.model flat, stdcall
option casemap:none

include \masm32\include\windows.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib

.data
DLLName     db "ASM-DLL", 0
flags       dd ?
dllInstance dd 0

.code
;the DLLMain function called upon loading and unloading of the DLL
DllEntry proc hInst:HINSTANCE, dwReason:DWORD, reserved1:DWORD
    push hInst
    pop dllInstance
	
    .if dwReason == DLL_PROCESS_ATTACH || dwReason == DLL_THREAD_ATTACH
        ;invoke MessageBox, NULL, addr DLLName, addr DLLName, MB_OK
        pushf
		pop flags
    ;.elseif dwReason == DLL_PROCESS_DETACH
        ;invoke MessageBox, NULL, addr DLLName, addr DLLName, MB_OK
    .endif

    mov eax, TRUE
    ret
DllEntry Endp

; this is the Shift Left
vSHL proc dest:DWORD, count:DWORD
    mov eax, dest
    mov ecx, count
    shl eax, cl

    ret
vSHL endp

; this is the Shift Arithmetic Left (signed)
vSAL proc dest:DWORD, count:DWORD
    mov eax, dest
    mov ecx, count
    sal eax, cl

    ret
vSAL endp

; this is the Shift Right
vSHR proc dest:DWORD, count:DWORD
    mov eax, dest
    mov ecx, count
    shr eax, cl

    ret
vSHR endp

; this is the Shift Arithmetic Right (signed)
vSAR proc dest:DWORD, count:DWORD
    mov eax, dest
    mov ecx, count
    sar eax, cl

    ret
vSAR endp

; this is the Rotate Left
vROL proc dest:DWORD, count:DWORD
    mov eax, dest
    mov ecx, count
    rol eax, cl

    ret
vROL endp

; this is the Rotate Left (through carry)
vRCL proc dest:DWORD, count:DWORD
    push flags
    popf
    
    mov eax, dest
    mov ecx, count
    rcl eax, cl
	
	pushf
	pop flags
	
    ret
vRCL endp

; this is the Rotate Right
vROR proc dest:DWORD, count:DWORD
    mov eax, dest
    mov ecx, count
    ror eax, cl

    ret
vROR endp

; this is the Rotate Right (through carry)
vRCR proc dest:DWORD, count:DWORD
    push flags
    popf
    
    mov eax, dest
    mov ecx, count
    rcr eax, cl
    
    pushf
    pop flags
    
    ret
vRCR endp

; tell windows where the DLLMain function is
End DllEntry